setwd("C:/Users/Mad Mike/Desktop")
slp=read.table("r_slp.txt", header=T)
attach(slp)

slp_pd_mean=c()

for(i in 1:12)
{
  slp_pd_mean=c(slp_pd_mean, mean(PD[which(MC==i & ROK>=1971 & ROK<=2000)]))
}

#teraz sd
slp_pd_sd=c()

for(i in 1:12)
{
  slp_pd_sd=c(slp_pd_sd, sd(PD[which(MC==i & ROK>=1971 & ROK<=2000)]))
 }

#obliczenie wartoc standaryzowanych
#obliczenie standaryzowanyh wartoci dla punktu PD
pd_st=(PD-slp_pd_mean)/slp_pd_sd

#oblicenia dla punktu pnocnego
slp_st_mean=c()

for(i in 1:12)
{
  slp_st_mean=c(slp_st_mean, mean(ST[which(MC==i & ROK>=1971 & ROK<=2000)]))
}

#teraz sd
slp_st_sd=c()

for(i in 1:12)
{
  slp_st_sd=c(slp_st_sd, sd(ST[which(MC==i & ROK>=1971 & ROK<=2000)]))
}

#obliczenie wartoc standaryzowanych
#obliczenie standaryzowanyh wartoci dla punktu PD
st_st=(ST-slp_st_mean)/slp_st_sd



#obliczenie NAO

nao=pd_st-st_st

barplot(nao[which(MC==1)], col=ifelse(nao>0,"red","blue"))


#obliczenia dla temperatury - konieczne bdzie usunici ecyklu rocznego
temp=read.table("r_air.txt", header=T)

plot(temp$TEMP, type="l")

#calculating annual cycle

temp_mean_y=c()
for(i in 1:12)
{
  temp_mean_y=c(temp_mean_y, mean(temp$TEMP[which(temp$MC==i)]))
}
plot(temp_mean_y)

temp_ac=rep(temp_mean_y, 64)

plot(temp_ac, type="l")

temp_sc=temp$TEMP-temp_ac

plot(temp_sc, type="l", col=2)

#usuwanie trendu
plot(temp_sc, type="l", col=1)
abline(lm(temp_sc~c(1:768)), col=2, lwd=2)

summary(lm(temp_sc~c(1:768)))
temp_trend=lm(temp_sc~c(1:768))

temp_sc_dt=temp_sc-temp_trend$fitted.values

plot(temp_sc, type="l", col=1)
lines(temp_sc_dt, type="l", col=2)


# rozpoznawanie zalenoci

data_final=cbind(slp$ROK, slp$MC,nao, temp_sc_dt)
data_final=as.data.frame(data_final)
colnames(data_final)=c("YEAR", "MC", "NAO", "TEMP")
attach(data_final)

plot(NAO[which(MC==1 | MC==2| MC==12) ], TEMP[which(MC==1| MC==2|MC==12)], )

#tutaj by moe warto wydzielic zmienne dla por roku... bedzie pozniej atwiej


#analiza zaleznoci (czekam na propozycje)
#korelacje


#regresja


#analiza jakosci funkcji regresji
#diagram Taylora (czny dla pr roku )


#analiza tabeli kontyngencji/ najpierw factorisation
nao_fac=cut(NAO, breaks=c(min(NAO)-1, quantile(NAO, 0.33),quantile(NAO, 0.66), max(NAO)+1), labels = c("BELOW", "NORMAL", "ABOVE"))
temp_fac=cut(TEMP, breaks=c(min(TEMP)-1, quantile(TEMP, 0.33),quantile(TEMP, 0.66), max(nao)+1), labels = c("BELOW", "NORMAL", "ABOVE"))
table=table(nao_fac[which(MC==1|MC==2|MC==12)], temp_fac[which(MC==1|MC==2|MC==12)])
table
chisq.test(table)

#kolmogorov smirnov
hist(TEMP[which(data_final$NAO< -1)], prob=T,col=rgb(1,0,0,0.5), ylim=c(0,0.4))
hist(TEMP[which(data_final$NAO>1)], prob=T, add=T, col=rgb(0,0,0,0.5))

plot(ecdf(TEMP[which(data_final$NAO<=-1)]))
lines(ecdf(TEMP[which(data_final$NAO>=-1)]), col=2)

qqplot(TEMP[which(data_final$NAO<=-1)],TEMP[which(data_final$NAO>=-1)] )
abline(0,1, col=2)

ks.test(TEMP[which(data_final$NAO<=-1)],TEMP[which(data_final$NAO>=-1)])
